#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pixelscale.h"
#include "readraw.h"
#include <time.h>

int main( int argc, char** argv )
{	double par = 1.2;
	const  int ITER_N = 512;

	ps_format  fmt_in;	
	ps_format  fmt_out;
	ps_size    size_in, size_out;
	ps_pixels  pix_in, pix_out;
	ps_rect    rect;
	int i, x, y;

	fmt_out.step = 3;
	fmt_out.offs = 0;

	fmt_in .step = 3;
	fmt_in.offs  = 0;

	time_t start,end;

	size_in.h = 200;
	size_in.w = 320;
	pix_in.pitch  = size_in.w * fmt_in.step;

	size_out.h = 1200;
	size_out.w = 1600;

	pix_out.pitch  = size_out.w * fmt_out.step;

	const char* PATH = "rawtest.data";
	const char* PATH_OUT = "rawout.data";
	ReadRaw( PATH, size_in.w, size_in.h, (char**)&pix_in.pixels );
	pix_out.pixels = (unsigned char*)malloc( size_out.h * pix_out.pitch );
	char dw = 0, dh = 0;
	ps_size size_ps;
	ps_info si = ps_new_perfect( fmt_in, size_in, fmt_out, size_out, dw, dh, 3, par, &size_ps );
	//ps_info si = ps_new_nn     ( fmt_in, size_in, fmt_out, size_out, dw, dh, 3                );
	//ps_info si = ps_new_soft   ( fmt_in, size_in, fmt_out, size_out, dw, dh, 3, 1.0           );
	rect.x = 0; rect.y = 0; rect.w = size_in.w-0; rect.h = size_in.h-0;
	start = clock();
	ps_rect rect_lp;
	for( i = 0; i < ITER_N; i++ )
	{	rect_lp = rect;
		ps_scale( si, pix_in, pix_out, &rect_lp );
	}
	end = clock();
	printf
	(	"Scaling %ix%i -> %ix%i at %i fps.\n",
		rect.w, rect.h, rect_lp.w, rect_lp.h,
		(int)( (double)ITER_N/(end-start)*CLOCKS_PER_SEC + 0.5)
	);
	ps_free( si );
	WriteRaw( (char*)pix_out.pixels, size_out.w, size_out.h, PATH_OUT );
	FreeRaw( (char*)pix_in .pixels  );
	FreeRaw( (char*)pix_out.pixels );

	return 0;
}
